<?php
namespace AustraliaPost\Extensions\Business\Orders;

use AustraliaPost\Extensions\Business\API\Business;
use AustraliaPost\Extensions\Business\Helpers\Utilities;

class Order_Summary_Download_Page
{
	/**
	 * The single instance of the class.
	 *
	 * @var Order_Summary_Download_Page
	 */
	protected static $_instance = null;

	/**
	 * @return Order_Summary_Download_Page
	 */
	public static function get_instance()
	{
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	/**
	 * Order_Summary_Download_Page constructor.
	 */
	public function __construct() {
		add_action('admin_menu', [$this, 'register_page']);
	}

	public function register_page()
	{
		add_submenu_page(
			null,
			'Download Order Summary',
			'Download Order Summary',
			'manage_options',
			'labels-pro-download-order-summary',
			[$this, 'download']
		);
	}

	public function download()
	{
		if (!isset($_GET['order_id'])) {
			wp_die('The order id must be present.');
		}

		$order_id = sanitize_text_field($_GET['order_id']);

		if (!$order_id) {
			wp_die('The order id must be present.');
		}

		$account_number = Utilities::accountNumber();
		$response = (new Business())->download_order_summary($account_number, $order_id);

		ob_clean();
		header("Content-type:application/pdf");
		echo $response;
		exit;
	}
}
